hdu 2829 Lawrence(斜率dp)

Lawrence

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 4930    Accepted Submission(s): 2274


Problem Description
T. E. Lawrence was a controversial figure during World War I. He was a British officer who served in the Arabian theater and led a group of Arab nationals in guerilla strikes against the Ottoman Empire. His primary targets were the railroads. A highly fictionalized version of his exploits was presented in the blockbuster movie, "Lawrence of Arabia".

You are to write a program to help Lawrence figure out how to best use his limited resources. You have some information from British Intelligence. First, the rail line is completely linear---there are no branches, no spurs. Next, British Intelligence has assigned a Strategic Importance to each depot---an integer from 1 to 100. A depot is of no use on its own, it only has value if it is connected to other depots. The Strategic Value of the entire railroad is calculated by adding up the products of the Strategic Values for every pair of depots that are connected, directly or indirectly, by the rail line. Consider this railroad: 


Its Strategic Value is 4*5 + 4*1 + 4*2 + 5*1 + 5*2 + 1*2 = 49.

Now, suppose that Lawrence only has enough resources for one attack. He cannot attack the depots themselves---they are too well defended. He must attack the rail line between depots, in the middle of the desert. Consider what would happen if Lawrence attacked this rail line right in the middle: 

The Strategic Value of the remaining railroad is 4*5 + 1*2 = 22. But, suppose Lawrence attacks between the 4 and 5 depots: 

The Strategic Value of the remaining railroad is 5*1 + 5*2 + 1*2 = 17. This is Lawrence's best option.

Given a description of a railroad and the number of attacks that Lawrence can perform, figure out the smallest Strategic Value that he can achieve for that railroad. 
 

Input
There will be several data sets. Each data set will begin with a line with two integers, n and m. n is the number of depots on the railroad (1≤n≤1000), and m is the number of attacks Lawrence has resources for (0≤m<n). On the next line will be n integers, each from 1 to 100, indicating the Strategic Value of each depot in order. End of input will be marked by a line with n=0 and m=0, which should not be processed.
 

Output
For each data set, output a single integer, indicating the smallest Strategic Value for the railroad that Lawrence can achieve with his attacks. Output each integer in its own line.
 

Sample Input
 
  
4 1 4 5 1 2 4 2 4 5 1 2 0 0
 

Sample Output
 
  
17 2

思路:
dp[i][j]表示0~i-1 个数操作j次后的最小值。
cost[0][i]表示0~i-1 个数没有操作前的值。
sum[i]表示a[0]~a[i-1]的前缀和。
则对于k<i cost[k][i]=cost[0][i]-cost[0][k]-sum[k]*(sum[i]-sum[k]);
则dp[i][j]=dp[k][j-1]+cost[k][i]
因为cost总是从0开始,所以直接省略。
dp[i][j]=dp[k][j-1]+cost[i]-cost[k]-sum[k]*sum[i]+sum[k]*sum[k];
按照j遍历,对每层的i进行斜率优化。

代码:
 
#include<bits/stdc++.h>
using namespace std;
#define ll long long
const int maxn=1005;
ll dp[maxn][maxn],a[maxn];
ll sum[maxn],cost[maxn],deq[maxn];
ll cal(ll k,ll i,ll j)
{
    return -sum[k]*sum[i]+dp[k][j-1]-cost[k]+sum[k]*sum[k];
}
bool check(ll f1,ll f2,ll f3,ll j)
{
    ll a1=-sum[f1],b1=dp[f1][j-1]-cost[f1]+sum[f1]*sum[f1];
    ll a2=-sum[f2],b2=dp[f2][j-1]-cost[f2]+sum[f2]*sum[f2];
    ll a3=-sum[f3],b3=dp[f3][j-1]-cost[f3]+sum[f3]*sum[f3];
    return (a2-a1)*(b3-b2)>=(b2-b1)*(a3-a2);
}
int main()
{
    int n,m;
    while(~scanf("%d%d",&n,&m))
    {
        if(n==0&&m==0)
            break;
        for(int i=0; i<n; i++)
            scanf("%lld",&a[i]);
        for(int i=0; i<n; i++)
            sum[i+1]=sum[i]+a[i];
        for(int i=0; i<n; i++)
        {
            cost[i+1]=cost[i];
            for(int j=0; j<i; j++)
                cost[i+1]+=a[i]*a[j];
        }
        for(int i=1; i<=n; i++)
            dp[i][0]=cost[i];
        for(ll j=1; j<=m; j++)
        {
            int s=0,t=1;
            deq[0]=0;
            for(ll i=1; i<=n; i++)
            {
                while(s<t-1&&cal(deq[s],i,j)>=cal(deq[s+1],i,j))
                    s++;
                dp[i][j]=cost[i]+cal(deq[s],i,j);
                while(s<t-1&&check(deq[t-2],deq[t-1],i,j))
                    t--;
                deq[t++]=i;
            }
        }
        printf("%lld\n",dp[n][m]);
    }
    return 0;
}

猜你喜欢

转载自blog.csdn.net/albertluf/article/details/81005675